// SweepAlgorithm.h: interface for the CSweepAlgorithm class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SWEEPALGORITHM_H__F5F2BEB6_6768_4864_9DE5_814A7904528B__INCLUDED_)
#define AFX_SWEEPALGORITHM_H__F5F2BEB6_6768_4864_9DE5_814A7904528B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Algorithm.h"
#include "VRPDoc.h"

struct sAngle {
    int NodeId;
    float Value;
};




class CSweepAlgorithm : public CAlgorithm  
{
public:
	void Solve();
	CSweepAlgorithm();
	CSweepAlgorithm(CVRPDoc* pDoc);
	virtual ~CSweepAlgorithm();

private:
	void RouteCustomers();
	sAngle* m_pAngleArray;
	void InitVariables();
	void SetAngles();
	float CountAngle(int x,int y);
};

#endif // !defined(AFX_SWEEPALGORITHM_H__F5F2BEB6_6768_4864_9DE5_814A7904528B__INCLUDED_)
